{This has the tip editing procedures.  Only one procedure is externally
visible and it is only called from the editing menu.}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{This block defines the compiler switch settings}
{$A+} {Always align variables on a word boundary}
{$B-} {use short-circuit boolean evaluation}
{$D+} {include debugging information}
{$E-} {shouldn't need to include 80X87 emulation (assumed >= 80486 CPU)}
{$F-} {no need for far calls in this application}
{$G+} {always use 80286 instructions (assumed >=80486 CPU)}
{$I+} {keep I/O checking enabled (unless locally necessary)}
{$L+} {local symbol information (helps in debugging)}
{$N+} {always assume a coprocessor is present}
{$O-} {overlays are not used in this application}
{$R-} {range checking is off for this application}
{$S+} {leave stack checking on since a lot of recursive calls are used}
{$V+} {strict checking of strings passed as Var procedure parameters}
{$X-} {always accept the value of a function call}
{End compiler switch block}
{-------------------------------------------------------------------------}

 
Unit te_tip1;

Interface
Uses t_util1;       {Defines nodePtr and flString types}
 
Procedure tipEdit(rt:nodePtr; fl:flString);
 
Implementation
Uses crt,           {Borland lo-res text screens}
     graph,         {Borland graphics package}
     te_util1;      {Type definitions, constants, utility procedures}


   {*******************************************************************}
   {This procedure provides the tip data editing features.}
   {*******************************************************************}
   Procedure tipEdit(rt:Nodeptr;fl:flString);
      Var
         ch : char;
         total :integer;
         current,run :nodePtr;
         chInt :integer;
         first :nodePtr;
 
      {*****************************************************************}
      {This procedure draws the top part of the screen for the tip
      editing module.}
      {*****************************************************************}
      Procedure drawTop;
         Begin
            writeln('***************************** Tip Data Edit Module ',
                       '****************************');
            writeln('          ___________________________________________',
                       '_________________________');
            writeln('number   |');
            writeln('tip name |');
            writeln('trait #1 |');
            writeln('trait #2 |');
            writeln('          -----------------------------------------',
                       '---------------------------');
            gotoXY(79,3);
            write('|');
            gotoXY(79,4);
            write('|');
            gotoXY(79,5);
            write('|');
            gotoXY(79,6);
            write('|');
            gotoXY(1,8);
            writeln('                            There are currently '
                                     ,total,' tips.');
         End; {procedure drawtop}
      {****************************************************************}
      {This procedure draws the bottom part of the tip editing screen.}
      {****************************************************************}
      Procedure drawBottom;
         Begin
            gotoXY(1,9);
            writeln('****************************************************',
                       '**************************');
            writeln('Which of the following would you like to do?');
            writeln('     (V)iew:     XY plot of Trait 1 vs. Trait 2.');
            writeln('     (C)hange:   change the traits of the active ',
                       '(leftmost) tip.');
            writeln('     (P)ower:    raise all the tips to a power.');
            writeln('     (L)og:      log base 10 transform all the tips.');
            writeln('     (A)ntilog:  tips equal 10 raised to the ',
                       'power given by tip.');
            writeln('     (S)cale:    multiply all the tips by a constant.');
            writeln('    c(O)nstant:  add a constant, see (L)og option.');
            writeln('     (D)ivide:   one trait by the other (e.g., create mass-specific values).');
            writeln('     (R)eturn:   return to the main editing menu.');
            writeln;
            writeln('     (->):       Right arrow to scroll to the right.');
            writeln('     (<-):       Left arrow to scroll to the left.');
            writeln('***************************************************',
                       '****************************');
            writeln('Please choose (V,C,P,L,S,R,<-,->)');
         End; {procedure drawBottom}
      {*********************************************************************}
      {This procedure draws the tip data into the proper place in
      the tip data editing screen.}
      {*********************************************************************}
      Procedure drawData(current:nodePtr);
         Const emptyTip = '                 ';
         Var
            now :nodePtr;
            i :integer;
            offset: integer;
            done :boolean;
         Begin
            now:=current;
            done:=false;
            For i:=0 To 3 Do Begin
               offset:=i*17 + 11;
               gotoXY(offset,3);
               If done
               Then write(emptyTip)
               Else write('      ',now^.tipnum,'  ');
               gotoXY(offset,4);
               If done
               Then write(emptyTip)
               Else write('      ',now^.name);
               gotoXY(offset,5);
               If done
               Then write(emptyTip)
               Else extendWrite(output,now^.dat[1]);
               gotoXY(offset,6);
               If done
               Then write(emptyTip)
               Else extendWrite(output,now^.dat[2]);
               If not(done) Then now := now^.tipR;
               done := (now = NIL);
            End; {for i}
         End; {procedure drawdata}
      {********************************************************************}
      {This procedure checks to see if any of the tip data are
      less than or equal to zero.}
      {********************************************************************}
      Procedure areNotPostive(first :nodePtr;
                              Var isTrue:boolean;
                              trait:integer);
         Var curNode : nodePtr;
         Begin
            isTrue := false;
            curNode := first;
            Repeat
               If (curNode^.dat[trait]<=0)
               Then isTrue := true
               Else curNode := curNode^.tipR
            Until (curNode = NIL) Or isTrue;
         End; {procedure arenotpostive}
      {********************************************************************}
      {This procedure checks to see if any of the tip data are
      less than or equal to zero.}
      {********************************************************************}
      Procedure areZero(first :nodePtr;
                        Var isTrue:boolean;
                        trait:integer);
         Var curNode : nodePtr;
         Begin
            isTrue := false;
            curNode := first;
            Repeat
               If (curNode^.dat[trait]=0)
               Then isTrue := true
               Else curNode := curNode^.tipR
            Until (curNode = NIL) Or isTrue;
         End; {procedure arezero}

      {*****************************************************************}
      {This procedure prompts and reads a trait choice (1 or 2) from the
       user.  The choice is returned as an integer.
      {*****************************************************************}
      Procedure getTraitNum(Var trait:integer);
         Begin
            gotoXY(1,12);
            writeln('Which trait do you wish to be affected? ',
                       '(Enter 1 or 2)');
            readInteger(trait,56,12);
            While Not (trait in [1,2]) do Begin
               If (trait<>1)and(trait<>2) Then Begin
                  gotoXY(1,13);
                  writeln('Please enter either 1 or 2.');
               End; {then}
               readInteger(trait,29,13);
            End; {while}
         End; {procedure getTraitNum}

      {******************************************************************}
      {This procedure prompts the user for a power factor, then
      takes all the tip data to that power.  Note that each
      of the two traits is treated separately.}
      {*****************************************************************}
      Procedure powerTips(first,current : nodePtr);
         Var
            p1,p2 :extended;
            zero : boolean;
            trait: integer;
         {**************************************************************}
         {This procedure recursively traverses the tips and takes
         all the tip data to the power specified.}
         {**************************************************************}
         Procedure power(nd :nodePtr; m :extended; trait:integer);
            Begin
               nd^.dat[trait]:=exp(m*ln(nd^.dat[trait]));
               If (nd^.tipR<>NIL) Then power(nd^.tipR, m, trait);
            End; {power}
         {**************************************************************}
         Begin {powertips}
            clrscr;
            drawTop;
            drawData(current); 
            getTraitNum(trait);
            gotoXY(1,15);
            areNotPostive(first,zero,trait);
            If (zero) Then Begin
               writeln('This program cannot take the tip data to a power because');
               writeln('one or more values is < or = 0.');
               ret('Please press any key to return to tip editing menu.');
            End {then}
            Else Begin
               writeln('You are in the exponential scaling submodule.');
               gotoXY(1,16);
               writeln('Please enter the power factor for trait #',trait,'.');
               writeln('Note: every tip node will have its trait #',trait,
                          ' brought to the power entered.');
               writeln('Note also that if you enter 1 that means no,',' change.');
               p1:=1;
               input1(p1,10,20);
               power(first,p1,trait);
               ret('Procedure Complete, enter any key to return to tip editing menu.');
            End; {else}
         End; {procedure powertips}
      {**************************************************************}
      {This procedure takes the log base 10 of all the tip data.}
      {**************************************************************}
      Procedure logTips(first,current : nodePtr);
         Var
            zero :boolean;
            ch :char;
            trait:integer;
         {**********************************************************}
         {This procedure replaces the trait value for each tip with
          its base 10 log.  Inappropriate use of recursion removed
          6 July 1999 PEM.                                          }
         {**********************************************************}
         Procedure logTp(first :nodePtr; trait:integer);
            Var curNode : nodePtr;
                log10 : extended;
            Begin
               log10 := ln(10);
               curNode := first;
               Repeat
                   curNode^.dat[trait]:=ln(curNode^.dat[trait])/log10;
                   curNode := curNode^.tipR
               Until curNode = NIL;
            End;
         {***********************************************************}
         Begin {logTips}
            clrscr;
            drawTop;
            drawData(current);
            gotoXY(1,12);
            getTraitNum(trait);
            areNotPostive(first,zero,trait);
            If (zero) Then Begin
               writeln('You cannot take the log base 10 of the tip data');
               writeln('because one or more values is < or = 0.');
               ret('Please press any key to return to tip editing menu.');
            End {then}
            Else Begin
               logTp(first,trait);
               ret('Procedure complete, press any key to return.');
            End; {else}
         End; {procedure logtips}
      {******************************************************************}
      {This procedure prompts the user for a scaling factor, then
      multiplies all the tip data by the factor.  Note that each
      of the two traits is treated separately.}
      {*****************************************************************}
      Procedure scaleTips(first,current : nodePtr);
         Var
            curTip : NodePtr;
            mul :extended;
            trait :integer;
         {**************************************************************}
         Begin {scaleTips}
            clrscr;
            drawTop;
            drawData(current);
            getTraitNum(trait);
            gotoXY(1,14);
            writeln('You are in the multiplicative scaling submodule.');
            writeln('Please enter the scaling factor for trait #',trait,'.');
            If trait=1
            Then writeln('Note that every tip node will have its first trait')
            Else writeln('Note that every tip node will have its second trait');
            writeln('multiplied by the number entered.');
            writeln('Note also that if you enter 1 that means no change.');
            mul:=1;
            input1(mul,10,20);
            curTip := first;
            Repeat
               curTip^.dat[trait] := curTip^.dat[trait]*mul;
               curTip := curTip^.tipR
            Until curTip = NIL;
            ret('Procedure Complete, enter any key to return to tip editing menu.');
         End; {procedure scaletips}
      {*****************************************************************}
      {This procedure takes the antilog base 10 of all the tip data.}
      {*****************************************************************}
      Procedure antiLogTips(first,current : nodePtr);
         Var
            ok :boolean;
            ch :char;
            trait :integer;
         {***************************************************************}
         {This procedure takes the antilog base 10 of all the tip data.
          Inappropriate use of recursion removed 6 July 1999 PEM.        }
         {***************************************************************}
         Procedure antiLogTp(first :nodePtr; trait:integer);
            Var curTip : nodePtr;
            Begin
               curTip := first;
               Repeat
                  curTip^.dat[trait]:=exp(curTip^.dat[trait]*ln(10));
                  curTip := curTip^.tipR;
               Until(curTip=NIL);
            End; {procedure antilogtp}
         {**************************************************************}
         {This procedure checks to see if any of the values are greater
          than 38, because this would cause an out of range error.
          Unnecessary tree walking remove 6 July 1999 PEM.              }
         {**************************************************************}
         Procedure antiLogOK(first :nodePtr; Var ok:boolean; trait :integer);
            Var curTip : nodePtr;
            Begin
               curTip := first;
               Repeat
                  If (curTip^.dat[trait]>38) Then ok:=false
                  Else curTip := curTip^.tipR;
               Until (curTip = NIL) Or Not(ok);
            End; {procedure antilogok}
         {***************************************************************}
         Begin {antilogtips}
            clrscr;
            drawTop;
            drawData(current);
            getTraitNum(trait);
            gotoXY(1,14);
            ok:=true;
            antiLogOK(first,ok,trait);
            If (not ok) Then Begin
               writeln('You cannot take the Antilog base 10 of the tip data');
               writeln('because a tip value is > 38.  Floating point',
                          ' overflow would occur.');
               ret('Please press any key to return to tip editing menu.');
            End {then}
            Else Begin
               antiLogTp(first,trait);
               ret('Procedure complete, press any key to return.');
            End; {else}
         End; {procedure antilogtips}
      {*****************************************************************}
      {This procedure adds a constant to one trait of all the tip data. }
      {*****************************************************************}
      Procedure addConstant(first,current : nodePtr);
         Var
            add : extended;
            trait :integer;
            ok :boolean;
            ch :char;
         {***************************************************************}
         {This procedure adds a constant to all the tip values for one
          trait.}
         {***************************************************************}
         Procedure addConstantTp(first     : nodePtr;
                                 trait     : integer;
                                 incrValue : extended); {the value to add}
            Var curTip : nodePtr;
            Begin
               curTip := first;
               Repeat
                  curTip^.dat[trait]:=curTip^.dat[trait]+incrValue;
                  curTip := curTip^.tipR;
               Until(curTip=NIL);
            End; {procedure antilogtp}
         {***************************************************************}
         Begin {addConstant}
            clrscr;
            drawTop;
            drawData(current);
            getTraitNum(trait);
            gotoXY(1,14);
            writeln('You are in the constant adding submodule.');
            writeln('Please enter the additive constant for trait #',trait,'.');
            If (trait = 1)
            Then writeln('Note: every tip node will have its first trait ',
                       'increased by the number entered.')
            Else writeln('Note: every tip node will have its second trait ',
                       'increased by the number entered.');
            writeln('Note also that if you enter 0 there will be no change.');
            add:=1;
            input1(add,10,20);
            ok:=true;
            addConstantTp(first,trait,add);
            ret('Procedure complete, press any key to return.');
         End; {procedure addconstant}
      {*****************************************************************}
      {This procedure divides one trait value by the other for all tips.}
      {*****************************************************************}
      Procedure divideTraits(first,current : nodePtr);
         Var
            zero :boolean;
            ch :char;
            trait :integer;
         {***************************************************************}
         {This procedure does the division of all the tip data.          }
         {***************************************************************}
         Procedure divideTips(first :nodePtr; trait:integer);
            Var curTip: nodePtr;
            Begin
               curTip :=first;
               Repeat
                  curTip^.dat[3-trait]:=
                               curTip^.dat[3-trait]/curTip^.dat[trait];
                  curTip := curTip^.tipR
               Until (curTip = NIL);
            End; {procedure antilogtp}
         {*****************************************************************}
         {This procedure inputs an integer from the user.  Either one for
          trait 1 or two for trait 2.}
         {*****************************************************************}
         Procedure getDenominatorTrait(Var trait:integer);
            Begin
               gotoXY(1,12);
               writeln('Which trait do you wish to divide by? (Enter 1 or 2)');
               Repeat           
                  If (trait<>1)and(trait<>2) Then Begin
                     gotoXY(1,13);
                     writeln('Please enter either 1 or 2.');
                  End; {then}
                  readInteger(trait,29,13);
               Until (trait=1) or (trait=2);
            End; {procedure getDenominator}
         {***************************************************************}
         Begin {divideTraits}
            clrscr;
            drawTop;
            drawData(current);
            getDenominatorTrait(trait);
            gotoXY(1,15);
            areZero(first,zero,trait);
            If zero Then Begin
               writeln('You cannot divide by trait ',trait);
               writeln('because one or more values is < or = 0.');
               ret('Please press any key to return to tip editing menu.');
            End {then}
            Else Begin
               divideTips(first,trait);
               write('Trait ',(3-trait):1,' will be replaced by trait ');
               writeln((3-trait):1,' divided by trait ',trait:1,'.');
               ret('Procedure complete, press any key to return.');
            End; {else}
         End; {procedure divideTraits}

      {****************************************************************}
      {This procedure allows the user to change the traits of one tip.
      The user must scroll through the tips until the one he or she
      wants to change is showing on the left (it is pointed to by
      current).  This procedure then prompts the user for new data.}
      {*****************************************************************}
      Procedure changeone(current: nodeptr);
         Begin
            clrscr;
            drawTop;
            drawData(current);
            gotoXY(1,12);
            writeln('You are in the change traits submodule, active node ',
                       'is: ',current^.name,'.');
            gotoXY(1,15);
            write('Currently trait #1 has the value ');
            extendWrite(output,current^.dat[1]);
            writeln;
            writeln('Please enter the new value, or "S" for the same.');
            input1(current^.dat[1],10,18);
            gotoXY(1,20);
            write('Currently trait #2 has the value ');
            extendWrite(output,current^.dat[2]);
            writeln;
            writeln('Please enter the new value, or "S" for the same.');
            input1(current^.dat[2],10,22);
            ret('Procedure complete, enter any key to return to tip editing menu.');
         End; {procedure changeone}
      {*********************************************************************}
      {This procedure draws the X-Y plot of the tip data: Trait 1 vs.
      Trait 2.  It uses a procedure in the t_util1 unit to calculate all
      the statistics.  This procedure would normaly be here, except it is
      also called by t_felsen to output stats to a file.

      The DrawTip procedure is similar to those graphing ones found in the
      unit T_felsen.  It shares many utility routines to draw various parts
      of the screen among other things with that unit through t_util1.  I
      would have liked to standardize the 'dumpdata' procedures, and the
      statistics calculating procedures, but they all dealt with data coming from
      different places like just the tips, or just the internal nodes so I
      choose not to.  All the procedures dealing with the X-Y plots are a
      little of a mess because there are so many of them, and several are
      very similar.  For more information see the documentation in T_util1.}
      {*********************************************************************}
      Procedure drawTip(nd:nodePtr;fl:flString);
         Var
            scalingFactor: traits;
            mx,my:integer;
            origin: itraits;
            stpk:statPak;
            spNode: nodePtr;
            clade: boolean;
            bail:boolean; {a throw away}
         {******************************************************************}
         {This procedure allows the user to request that a single tip or all
          the tips in a clade be displayed specially.                       }
         {******************************************************************}
         Procedure tipPlotOptions(Var spNode: nodePtr;Var wholeClade: boolean);
            Var
               xPos : integer;
               yPos : integer;
               ndName : nameString;
               userChar : char;
               noGood : boolean;
            Begin
               writeln;
               writeln('Would you like to plot a single tip with an open circle?');
               write('(Y/N/Any other character = N): ');
               xPos := whereX;
               yPos := whereY;
               writeln;
               gotoxy(xPos,yPos);
               userChar := readKey;
               gotoxy(1,yPos+3);
               If ((userChar = 'Y') or (userChar = 'y')) Then Begin
                  wholeClade := false;
                  writeln;
                  write('What is the two character name of the node (case matters)? ');
                  readln(ndName);
                  nogood := true;
                  While (noGood) Do Begin
                     checkName(rt,ndName,noGood,spNode);
                     If (noGood = false) Then Begin
                        If (spNode^.sibL <> NIL) Then Begin
                           writeln('The node ',ndName,' is not a tip.');
                           noGood := true;
                        End {then}
                     End
                     Else
                        writeln('No node with the name ',ndName,' could be found in the tree.');
                     If (noGood)
                     Then Begin
                        write('Enter a new name, or carriage return to give up: ');
                        readln(ndName);
                        If (ndName = '')  Then Begin
                           noGood := false;
                           spNode := NIL;
                        End; {then}
                     End; {then}
                  End; {while}
               End {then}
               Else Begin
                  wholeClade := true;
                  writeln('Would you like to see all the tips within a clade displayed with an open');
                  write('circle? (Y/N/Any other character = N): ');
                  userChar := readKey;
                  writeln;
                  If ((userChar = 'Y') or (userChar = 'y')) Then Begin
                     writeln;
                     writeln('What is the two character name of the clade''s basal ');
                     write('(root) node (case matters)? ');
                     readln(ndName);
                     nogood := true;
                     While (noGood) Do Begin
                        checkName(rt,ndName,noGood,spNode);
                        If (noGood = false) Then Begin
                           If (spNode^.sibL = NIL) Then Begin
                              writeln('The node ',ndName,' is a tip, so it is not the base of a clade.');
                              noGood := true;
                           End {then}
                        End
                        Else
                           writeln('No node with the name ',ndName,' could be found in the tree.');
                        If (noGood) Then Begin
                           write('Enter a new name, or carriage return to give up: ');
                           readln(ndName);
                           If (ndName = '') Then Begin
                              noGood := false;
                              spNode := NIL;
                              wholeClade := false;
                           End; {then}
                        End; {then}
                     End; {while}
                  End; {then}
               End; {else}
               writeln;                          { might prevent screen overwrites }
            End; {procedure tipPlotOptions}
         {******************************************************************}
         {This function is a helper for dumpData.}
         {******************************************************************}
         Function ancestor(inode:nodePtr;cnode:nodePtr):boolean;
            Begin
               While ((cnode <> inode) And
                      (cnode <> nil))
                 Do cnode := cnode^.ancestor;
               If cnode = nil Then ancestor := false
               Else ancestor := true;
            End; {function ancestor}

         {******************************************************************}
         {This procedure traverses the tree and at each tip it plots a data
         point relying on orgn,sf, and min to translate from tip data value
         to pixel number.}
         {*******************************************************************}
         Procedure dumpData(orgn:itraits;
                            sf,min:traits;
                            nd:nodePtr;
                            n1,n2:integer);
            Var
               coor:itraits;
            Begin
               While (nd <> nil) Do Begin
                  coor[1]:=orgn[1]+round(sf[1]*(nd^.dat[n1]-min[n1]));
                  coor[2]:=orgn[2]-round(sf[2]*(nd^.dat[n2]-min[n2]));
                  If (nd = spNode) Then openCircle(coor)
                  Else
                     If (clade and ancestor(spNode,nd)) Then openCircle(coor)
                     Else star(coor);
                  nd := nd^.tipR;
               End; {while nd}
            End; {procedure dumpdata}
         {*******************************************************************}
         Begin {drawTip}
            clrscr;
            writeln('Scatterplot of raw tip data will follow');
            writeln;
            tipStat(nd,stpk);
            tipPlotOptions(spNode,clade);
            graphicsOn(mx,my);
            initPlot(stpk.n1,
                     stpk.n2,
                     stpk.min,
                     stpk.max,
                     fl,
                     scalingFactor,
                     origin,
                     mx,
                     my);
            showAxes(origin,stpk.n1,stpk.n2,mx,my);
            outTextXY(0,0,'Plot of tip data.');
            dumpData(origin,scalingFactor,stpk.min,nd,stpk.n1,stpk.n2);  
            setLineStyle(0,0,1);
            plotLine(stpk.ls,
                     stpk.lsy,
                     stpk.min,
                     stpk.max,
                     scalingFactor,
                     origin,
                     stpk.n1,
                     stpk.n2);
            outTextXY(origin[1],
                      my-2*oneLine,
                      ' Solid line = least squares linear regression');
            dumpStat(stpk,mx,my,bail,false);
         End; {procedure drawTip}
      {*******************************************************************}
      Begin {tipEdit}
         prepareTips(rt,total,current);
         first:=current;
         Repeat
            clrscr;
            drawTop;
            drawBottom;
            Repeat
               drawData(current);
               gotoXY(39,24);
               ch:=Upcase(readKey);
               chInt:=ord(ch);       {check for right or left arrow keys}
               If ((chint = 75) And (current^.tipL <> NIL))
               Then current:= current^.tipL;               {go left one tip}
               If ((chint = 77) And (current^.tipR <> NIL))
               Then current:= current^.tipR;               {right one tip}
            Until ( ch In ['C','P','L','S','R','A','V','O','D']);
            Case ch Of
                'C' : changeOne(current);          {change a value}
                'P' : powerTips(first,current);    {power transform}
                'L' : logTips(first,current);      {log transform}
                'A' : antiLogTips(first,current);  {10^x transform}
                'S' : scaleTips(first,current);    {scaling transform}
                'V' : drawTip(first,fl);           {graph of tip values}
                'O' : addConstant(first,current);  {add a constant}
                'D' : divideTraits(first,current); {divide one trait by the other}
            End; {case ch}
         Until (ch = 'R');
         ret('Please press any key to return to the main editing menu.');
      End; {procedure tipedit}
End. {module te_tip1}
