{This unit just does the tree editing ... the bulk of the entire program!}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{This block defines the compiler switch settings}
{$A+} {Always align variables on a word boundary}
{$B-} {use short-circuit boolean evaluation}
{$D+} {include debugging information}
{$E-} {shouldn't need to include 80X87 emulation (assumed >= 80486 CPU)}
{$F-} {no need for far calls in this application}
{$G+} {always use 80286 instructions (assumed >=80486 CPU)}
{$I+} {keep I/O checking enabled (unless locally necessary)}
{$L+} {local symbol information (helps in debugging)}
{$N+} {always assume a coprocessor is present}
{$O-} {overlays are not used in this application}
{$R-} {range checking is off for this application}
{$S+} {leave stack checking on since a lot of recursive calls are used}
{$V+} {strict checking of strings passed as Var procedure parameters}
{$X-} {always accept the value of a function call}
{End compiler switch block}
{-------------------------------------------------------------------------}



Unit t_edit1;
Interface

Uses t_util1;      {Utility functions, type definitions, constants.}

Procedure EditTree(var realroot: nodeptr; livefile:boolean;fl:flstring);

Implementation

Uses crt,          {Borland lo-res screen text module}
     graph,        {Borland graphics module}
     te_util1,     {Utility functions local to this unit.}
     te_see1,      {graphical editing procedure.}
     te_tip1,      {tip editing procedure.}
     te_brch1;     {branch length editing procedure.}
{***************************************************************************}
{This is the part of the program that gets a little messy.  The messiness
comes in because I am dealing with calls to Turbo's runtime library to work
with the graphics screen.  However, it is organized like the main program.
The main code of this procedure is a menu that allows the user to choose
between 4 things.  The procedures of this Procedure are organized as in
the main Programs: first some general purpose ones, then one big one for
each of the options of the menu.  It is worth noting that the procedure
"Seeit" deals with most of the graphics, and has its own menu driven system
that has many more options and is therefore messier than any other in this
program.
{***************************************************************************}
Procedure editTree(Var realroot: nodePtr; liveFile:boolean; fl:flstring);
   Var
      height : extended;
      place : nodePtr;
      rt: nodePtr;
      ch :char;
      dummyChar : char;
      mx,my : integer;

   {************************************************************************}
   {This procedure prints the tree to the screen.  The user may then wish
   to use their own means to print the screen.}
   {************************************************************************}
   Procedure fullScreen(r:nodePtr);
      Var
         lengthMult : extended;
         ch : char;
         thick : boolean;
         mx,my:integer;
      Begin
         clrscr;
         writeln('The program can display the tree with thick (3 pixel) lines or');
         writeln('thin (1 pixel) lines.  Note: these are the only options Turbo');
         writeln('Pascal supports.  Thick lines are not recommended for trees with');
         writeln('more than 50 tips.');
         writeln;
         write('Do you want to see the tree with thick lines? (Y/N or CR for thin) ');
         ch:=readkey;
         While ((upcase(ch) <> 'Y') and (upcase(ch) <> 'N') and (ord(ch)<>13)) Do Begin
            writeln('Enter Y for thick lines, N for thin lines: ');
            readln(ch);
         End; {while ... and ...}
         If (upcase(Ch) = 'Y')
         Then thick := true
         Else thick := false;
         writeln;
         writeln('As soon as you press a key, you will see the tree.');
         writeln('When you are done viewing the tree just press another ',
                             'key to return.');
         writeln;
         writeln('If you want to Print Screen, you should save the file');
         writeln('   first and afterward quit the program and reenter,');
         writeln('   because Print Screen may mess up some things.');
         ch:=readkey;
         graphicson(mx,my);   {turn on graphics}
         clearviewport;       {clear screen}
         setbkcolor(cback);
         setcolor(white);
         If thick
         Then setlinestyle(SolidLn,0,ThickWidth);
         drawprintabletree(rt,lengthmult,0.98,mx,my);
         ch:=readkey;
         setlinestyle(SolidLn,0,NormWidth);   {This might not be necessary}
         Closegraph;  {exit graphics mode}
      End;


{**************************************************************************}
{This is the body of the editing module.  It is mainly a menu.}
{**************************************************************************}
   Begin {editTree}
      If Not liveFile
      Then Begin
         clrscr;
         writeln('You do not have a tree in memory.');
         writeln('In order to edit a tree you must input one ',
                                 'into memory.');
         writeln('You can do this by reading one in from disk,');
         writeln('   or by Creating a new one from the main menu.');
         ret('Please press any key to return to the Main Menu.');
         exit; {from this procedure}
      End; {then}
      rt:=realroot;
      place:=rt;
      Repeat
         Repeat
            clrscr;
            writeln('************************** Editing Module ************',
                                          '***************');
            If rt<>realroot
            Then
               writeln('*!*!*!*!*!* right now you are only working on ',
                                      'part of the tree *!*!*!*!*!*!*')
            Else writeln;
            writeln('From here, you can:');
            writeln('   (E)dit the tree graphically.  You will not ',
                                                      'see this menu.');
            writeln('   (B)ranch length manipulations.');
            writeln('   (T)ip data manipulations.');
            writeln('   (F)ull screen print.  For a prettier screen dump.');
            writeln('   (R)eturn to the Main Menu.');
            writeln('While editing the tree graphically, you can:');
            writeln('   (A)dd a branch to the branch you are on.');
            writeln('   (C)hange the name and/or values of a node.');
            writeln('   (D)raw a horizontal line through current node.');
            writeln('   (E)dit just the subtree descended from the current',
                                                     ' node. ');
            writeln('   (G)o to tip or node name.');
            writeln('   (L)ength change - alter the length of a branch.');
            writeln('   r(O)tate node - exchange left and right subtrees.');
            writeln('   (P)op - undo the E command.  Lets you work with ',
                              'the whole tree again.');
            writeln('   (R)eturn will get you back here.');
            writeln('   (S)calar extension of all branches at',
                                 ' current height.');
            writeln('   (T)rim off the branch you are on and all',
                                ' of its children.');
            writeln('   (V) - Reroot the tree at the current node or branch');
            writeln('To move around the tree while editing it, the Left arrow takes you to the');
            writeln('   left child, Right arrow takes you right, and Down goes to parent node.');

            gotoxy(1,25);
            write('Please choose (E/B/T/F/R) ');
            ch:=UpCase(readkey);
         Until ch in ['E','T','B','F','R'];

         If ch in ['E','B'] Then Begin
            height := 0.0;
            findheight(rt,rt,0.0,height);
            If (height = 0) Then Begin
               clrscr;
               writeln('Warning: Your tree has a total height of 0.');
               writeln('         It will be displayed as a series of knots on a line.');
               writeln;
               writeln('Press any key to continue');
               dummyChar := readkey;
            End; {then}
         End; {then}
         Case ch Of
             'T' : tipEdit(rt,fl);
             'E' : seeit(realRoot,rt,place);
             'F' : fullScreen(rt);
             'B' : branchEdit(realRoot,rt);
         end;
      Until ch='R';
      { ret('Please press any key to return to the Main Menu.'); }
   End; {procedure editTree}

End.  {unit t_edit1}
